# Enum Class ClassFile.DebugElementsOption

java.lang.Object
java.lang.Enum<ClassFile.DebugElementsOption>
java.lang.classfile.ClassFile.DebugElementsOption

All Implemented Interfaces:
  `Serializable, ClassFile.Option, Comparable<ClassFile.DebugElementsOption>, Constable`

Enclosing interface:
  `ClassFile`

public static enum ClassFile.DebugElementsOption extends Enum<ClassFile.DebugElementsOption> implements ClassFile.Option
The option describing whether to process or discard debug `PseudoInstruction`s in the traversal of a `CodeModel` or a `CodeBuilder`. The default is `PASS_DEBUG` to process debug pseudo-instructions as all other `CodeElement`.

Debug pseudo-instructions include `LocalVariable`, `LocalVariableType`, and `CharacterRange`. Discarding debug elements may reduce the overhead of parsing or transforming `class` files and has no impact on the run-time behavior.

Since:
  24
See Also:
  - `ClassFile.LineNumbersOption`

## Nested Class Summary

### Nested classes/interfaces declared in class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`DROP_DEBUG`
Drop debug pseudo-instructions from traversal and builders.
`PASS_DEBUG`
Process debug pseudo-instructions like other member elements of a `CodeModel`.

## Method Summary

Modifier and Type
Method
Description
`static ClassFile.DebugElementsOption`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static ClassFile.DebugElementsOption[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods declared in class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### PASS_DEBUG

public static final ClassFile.DebugElementsOption PASS_DEBUG
Process debug pseudo-instructions like other member elements of a `CodeModel`.

### DROP_DEBUG

public static final ClassFile.DebugElementsOption DROP_DEBUG
Drop debug pseudo-instructions from traversal and builders.

## Method Details

### values

public static ClassFile.DebugElementsOption[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static ClassFile.DebugElementsOption valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null